package fileserver.client;

import fileserver.share.*;
import java.rmi.*;
import javax.swing.*;
import java.awt.*;

/**
 * <p>Title: File Server</p>
 * <p>Description: Bezestavov File Server pomoc RMI</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Jan Doleel
 * @version 1.0
 */

public class Client {
  static Session sess;

  public static void main(String args[]) {
    if (System.getSecurityManager() == null) {
      System.out.println("Creating own security manager");
      System.setSecurityManager(new RMISecurityManager());
    }

    try {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch (Exception e) {
      e.printStackTrace();
    }

    DialogFrame dg = new DialogFrame();
    dg.validate();
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    Dimension frameSize = dg.getSize();
    if (frameSize.height > screenSize.height) {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width) {
      frameSize.width = screenSize.width;
    }
    dg.setLocation( (screenSize.width - frameSize.width) / 2,
                      (screenSize.height - frameSize.height) / 2);
    dg.setVisible(true);
    if(!dg.getConfirm()) {
      System.exit(1);
    }
    sess = dg.getSession();

    try {
      FileServerInt fs;
      String name = "//" + dg.getHost() + ":" + dg.getPort() + "/FileServer";
      fs = (FileServerInt) Naming.lookup(name);
      MainFrame frame = new MainFrame(fs, sess);
      frame.validate();
      screenSize = Toolkit.getDefaultToolkit().getScreenSize();
      frameSize = frame.getSize();
      if (frameSize.height > screenSize.height) {
        frameSize.height = screenSize.height;
      }
      if (frameSize.width > screenSize.width) {
        frameSize.width = screenSize.width;
      }
      frame.setLocation( (screenSize.width - frameSize.width) / 2,
                        (screenSize.height - frameSize.height) / 2);
      frame.setVisible(true);
    }
    catch (Exception e) {
      System.err.println("Data exception: " + e.getMessage());
      e.printStackTrace();
      System.exit(1);
    }
    dg = null;

  }
}