package fileserver.server;

import fileserver.share.*;
import java.rmi.*;
import java.rmi.server.*;
import java.util.*;
import java.io.*;

/**
 * <p>Title: File Server</p>
 * <p>Description: Bezestavov File Server pomoc RMI</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Jan Doleel
 * @version 1.0
 */

public class FileServer extends UnicastRemoteObject implements FileServerInt {
  private Vector share;

  public FileServer() throws RemoteException {
    super();
    share = new Vector(10);
    this.setShare(new Session(null, null, new File("c:/")));
    this.setShare(new Session(null, null, new File("classes")));
    this.setShare(new Session(null, null, new File("src")));
  }

  public FileList list(Session s) throws RemoteException {
    FileList list = new FileList();
    if(s.getFile() == null) {
      Iterator i = share.iterator();
      while(i.hasNext()) {
        FileNode node = new FileNode((File)i.next(), true, true);
        list.add(node);
      }
    }
    else {
      if(this.authenticate(s)) {
        File[] l = s.getFile().listFiles();
        if (l != null) {
          int size = l.length;
          for (int i = 0; i < size; i++) {
            list.add(new FileNode(l[i], l[i].isDirectory(), true));
          }
        }
      }
    }
    return list;
  }

  public void put(MyFile f, Session s) throws RemoteException {
    f.saveFile(s.getFile());
  }

  public MyFile get(Session s) throws RemoteException {
    if(!authenticate(s) || s.getFile().isDirectory()) {
      return null;
    }
    else {
      return new MyFile(s.getFile().getAbsolutePath());
    }
  }

  public void setShare(Session s) throws RemoteException {
    if(s.getFile().isDirectory()) {
/*      boolean can = true;
      Iterator i = share.iterator();
      while(i.hasNext()) {
        if(((File) i.next()).equals(s.getFile())) {
          can = false;
        }
      }
      if(can) {*/
        System.out.println("Sharing: " + s.getFile());
        share.add(s.getFile());
//      }
    }
  }

  public void delete(Session s) throws RemoteException {
    del(s.getFile());
  }

  private void del(File f) {
    if(f.isDirectory()) {
      File[] l = f.listFiles();
      for(int i = 0; i < l.length; i++) {
        this.del(l[i]);
      }
    }
    f.delete();
  }

  public void createDir(Session s) throws RemoteException {
    if(!s.getFile().exists()) {
      s.getFile().mkdir();
    }
  }

  private boolean authenticate(Session s) {
    return true;
  }
}