package fileserver.server;

import fileserver.share.*;
import java.rmi.registry.*;
import java.rmi.*;

/**
 * <p>Title: File Server</p>
 * <p>Description: Bezestavov File Server pomoc RMI</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Jan Doleel
 * @version 1.0
 */

public class Server {
  private static int port = 1099;
  private static String host = "localhost";

  public static void main(String[] args) {
    if (System.getSecurityManager() == null) {
      System.setSecurityManager(new RMISecurityManager());
    }
    try {
      LocateRegistry.createRegistry(port);
    }
    catch(Exception e) {
      System.out.println("RMIRegistry pravdepodobne jiz bezi...");
      System.err.println("Chyba: " + e.getMessage());
    }
    try {
      FileServerInt fs = new FileServer();
      Naming.bind("//" + host + ":" + port + "/FileServer", fs);
    }
    catch(Exception e) {
      e.printStackTrace();
      System.err.println("Chyba: " + e.getMessage());
      System.exit(1);
    }
    System.out.println("Ready to do file server");
  }
}