package fileserver.share;

import java.io.*;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 * <p>Title: File Server</p>
 * <p>Description: Bezestavov File Server pomoc RMI</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author Jan Doleel
 * @version 1.0
 */

public class FileNode extends DefaultMutableTreeNode implements Serializable, Comparable {
  private String path = null;
  private String name = null;
  private boolean dir = false;
  private boolean access = false;

  public FileNode(File f, boolean d, boolean a) {
    path = f.getAbsolutePath();
    name = f.getName();
    if(name.length() == 0) {
      name = path;
    }
    dir = d;
    access = a;
  }

  public String getFullPath() {
    return path;
  }

  public String getName() {
    return name;
  }

  public boolean isDir() {
    return dir;
  }

  public boolean haveAccess() {
    return access;
  }

  public String toString() {
    return name;
  }

  public int compareTo(Object o) {
    if (o instanceof FileNode) {
        FileNode comp = (FileNode) o;
        return name.compareTo(comp.toString());
    }
    else {
      return -1;
    }
  }

  public boolean equals(Object o) {
    if (o instanceof FileNode) {
        FileNode comp = (FileNode) o;
        return path.equals(comp.path);
    }
    else {
      return false;
    }
  }
}